gmtset ANNOT_FONT_PRIMARY Helvetica  HEADER_FONT_SIZE 12p HEADER_OFFSET -0.1c
gmtset ANNOT_FONT_SIZE 11p LABEL_FONT_SIZE 12p ANNOT_OFFSET 0.1c LABEL_OFFSET 0.03c
gmtset TIME_FORMAT_PRIMARY abbreviated CHAR_ENCODING ISOLatin1+
gmtset GRID_PEN_PRIMARY thin,-- TICK_LENGTH -0.165c
gmtset PLOT_DATE_FORMAT -o PLOT_DEGREE_FORMAT ddd
gmtset BASEMAP_TYPE plain

fig=Figure_2_retrospective
m1=5.95
m2=8.25
p1=-0.5
p2=35.5
range=${m1}/${m2}/${p1}/${p2}
psbasemap -R$range -JX6i/3.65i -Ba0.5f0.1:"Magnitude, M@-ET@-":/a5f1:"Ratio (in %), N@-M@-/N@-total@-"::."(a) Preceded by an M6+ EQ in 10 days":WSn -K -X1i -Y7i -G255 -P > $fig.ps
inp0=inp_stat
ls *_T10_stat > $inp0
np=`wc $inp0 | awk '{print $1}'`
echo $np
if [ -e Table_10 ] ; then
   rm Table_10
fi
touch Table_10

for i in `seq 1 $np`
do
   inp=`awk -v i=$i 'NR==i {print $1}' $inp0`
   col=`awk '{if($4==1000) print "0/100/255"; else if($4==330) print  "255/0/255"; else if ($4==100) print "178/230/10"; else if ($4==500) print "50/50/50"; else if ($4==50) print "255/0/0"}' $inp | sort -u | awk '{print $1}'`
   ss=`awk '{if($4==1000) print "i0.12"; else if($4==330) print  "t0.12"; else if ($4==100) print "c0.10"; else if ($4==500) print "s0.09"; else if ($4==50) print "s0.125"}' $inp | sort -u | awk '{print $1}'`
   awk '{print $1,$13}' $inp | psxy -R -J -O -K -S${ss}i -G$col -W0.3p/0 >> $fig.ps
   dist=`awk 'NR==1 {print $4}' $inp`
   y=`echo $p1 $p2 $i | awk '{print $2*0.7-($2-$1)*0.05*($3-1)}'`
   echo $dist $y
   psxy -R -J -O -K -S${ss}i -G$col -W0.3p/0 >> $fig.ps << EOD
6.15 $y 
EOD
   pstext -R -J -O -K  >> $fig.ps << EOD
6.2 $y 12 0 1 LM $dist km 
EOD
   echo " M@-ET@-  N@-total@- " $dist"km" > Table_$i
   awk -v d=$dist '{print $1,$9,$7}' $inp >> Table_$i
   paste Table_10 Table_$i > xx
   mv xx Table_10
   rm Table_$i 
done
awk 'NR==1 || ($1<=9.5 && $2>0) {print $1,$2,$3,$6,$9,$12}' Table_10 | sort -n -k 1 > Table_retrospective_10days.txt
rm Table_10


range1=${m1}/${m2}/5/2000
psbasemap -R$range1 -JX6i/3.65il -Ba0.5f0.1/a1f3p:"Total number of EQs with M@-ET@-, N@-total@-":E -O -K >> $fig.ps
echo $np
for i in `seq 1 $np`
do
   inp=`awk -v i=$i 'NR==i {print $1}' $inp0`
   col=`awk '{if($4==1000) print "0/100/255"; else if($4==330) print  "255/0/255"; else if ($4==100) print "178/230/10"; else if ($4==500) print "50/50/50"; else if ($4==50) print "255/0/0"}' $inp | sort -u | awk '{print $1}'`
   echo " *****" $i $inp $col
done
awk '$10>0 {print $1,$9}' $inp | psxy -R -J -O -K -W0.5p/0 >> $fig.ps

inp0=inp_stat21
ls *_T21_stat > $inp0
np=`wc $inp0 | awk '{print $1}'`
if [ -e Table_21 ] ; then
   rm Table_21
fi
touch Table_21
psbasemap -R$range -JX6i/3.65i -Ba0.5f0.1:"Magnitude, M@-ET@-":/a5f1:"Ratio (in %), N@-M@-/N@-total@-"::."(b) Preceded by an M6+ EQ in 21 Days":WSn -K -Y-4.5i -O -G255 >> $fig.ps
for i in `seq 1 $np`
do
   inp=`awk -v i=$i 'NR==i {print $1}' $inp0`
   col=`awk '{if($4==1000) print "0/100/255"; else if($4==330) print  "255/0/255"; else if ($4==100) print "178/230/10"; else if ($4==500) print "50/50/50"; else if ($4==50) print "255/0/0"}' $inp | sort -u | awk '{print $1}'`
   ss=`awk '{if($4==1000) print "i0.13"; else if($4==330) print  "t0.13"; else if ($4==100) print "c0.10"; else if ($4==500) print "s0.09"; else if ($4==50) print "s0.135"}' $inp | sort -u | awk '{print $1}'`
   awk '{print $1,$13}' $inp | psxy -R -J -O -K -S${ss}i -G$col -W0.3p/0 >> $fig.ps

   echo $inp $col
   dist=`awk 'NR==1 {print $4}' $inp`
   y=`echo $p1 $p2 $i | awk '{print $2*0.97-($2-$1)*0.05*($3-1)}'`
   echo $dist $y
   echo " M@-ET@-  N@-total@- " $dist"km" > Table_$i
   awk -v d=$dist '{print $1,$9,$7}' $inp >> Table_$i
   paste Table_21 Table_$i > xx
   mv xx Table_21
   rm Table_$i 
done
awk 'NR==1 || ($1<=9.5 && $2>0) {print $1,$2,$3,$6,$9,$12}' Table_21 | sort -n -k 1 > Table_retrospective_21days.txt
rm Table_21

psbasemap -R$range1 -JX6i/3.65il -Ba0.5f0.1:"Magnitude, M@-ET@-":/a1f3p:"Total Number of EQs with M@-ET@-, N@-total@-":E -O -K >> $fig.ps
echo $np
for i in `seq 1 $np`
do
   inp=`awk -v i=$i 'NR==i {print $1}' $inp0`
   col=`awk '{if($4==1000) print "0/100/255"; else if($4==330) print  "255/0/255"; else if ($4==100) print "178/230/10"; else if ($4==500) print "50/50/50"; else if ($4==50) print "255/0/0"}' $inp | sort -u | awk '{print $1}'`
   echo " *****" $i $inp $col
done
   awk '$10>0 {print $1,$9}' $inp | psxy -R -J -O -K -W0.5p/0 >> $fig.ps


pwd | psxy -R -J -O -H >> $fig.ps
ps2pdf $fig.ps 
#evince $fig.pdf &
rm $fig.ps
#cp $fig.pdf ../
